#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

/**
 * n m deltaTree(dt) on off ask
 * dt = -inf - bamboo, +inf - ezh
 * '+' will occur with prob on / (on + off + ask) ...
 * **/

void putQuery(int v, int u) {
    printf("? %i %i\n", v, u);
}


void putEdge(pair<int, int> e) {
    printf("! %i %i\n", e.first, e.second);
}


void putOn(int v) {
    printf("+ %i\n", v);
}


void putOff(int v) {
    printf("- %i\n", v);
}


int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (m < n) {
        m = n + 1;
    }
    vector<int> order(n);
    for (int i = 1; i <= n; i++) {
        order[i - 1] = i;
    }
    shuffle(order.begin() + 1, order.end());
    int deltaTree = atoi(argv[3]);
    vector<pair<int, int>> edges;
    for (int i = 1; i < n; i++) {
        int ind = rnd.wnext(i, deltaTree);
        edges.push_back(make_pair(order[ind], order[i]));
    }
    int on = atoi(argv[4]);
    int off = atoi(argv[5]);
    int ask = atoi(argv[6]);
    vector<int> good = {1};
    vector<int> valid = {1}, invalid;

    printf("%i %i\n", n, m);
    m -= n - 1;
    int ql = -m - 100;

    function<char()> generateQ = [&]() {
        int res = rnd.next(1, on + off + ask);
        if (res <= on && !invalid.empty()) {
            return '+';
        }
        res -= on;
        if (res <= off && !valid.empty()) {
            return '-';
        }
        return '?';
    };
    for (auto e : edges) {
        ql++;
        putEdge(e);
        good.push_back(e.second);
        valid.push_back(e.second);
        for (int i = 0; i < rnd.wnext(m + 1, ql) and m > 0; i++, m--) {
            char c0 = generateQ();
            if (c0 == '?') {
                int v = rnd.next(1, n);
                int u = rnd.next(1, n);
                while (v == u) {
                    u = rnd.next(1, n);
                }
                putQuery(v, u);
            } else if (c0 == '+') {
                int ind = rnd.next(invalid.size());
                swap(invalid[ind], invalid.back());
                putOn(invalid.back());
                valid.push_back(invalid.back());
                invalid.pop_back();
            } else {
                int ind = rnd.next(valid.size());
                swap(valid[ind], valid.back());
                putOff(valid.back());
                invalid.push_back(valid.back());
                valid.pop_back();
            }
        }
    }
    while (m > 0) {
        char c0 = generateQ();
        if (c0 == '?') {
            int v = rnd.next(1, n);
            int u = rnd.next(1, n);
            while (v == u) {
                u = rnd.next(1, n);
            }
            putQuery(v, u);
        } else if (c0 == '+') {
            int ind = rnd.next(invalid.size());
            swap(invalid[ind], invalid.back());
            putOn(invalid.back());
            valid.push_back(invalid.back());
            invalid.pop_back();
        } else {
            int ind = rnd.next(valid.size());
            swap(valid[ind], valid.back());
            putOff(valid.back());
            invalid.push_back(valid.back());
            valid.pop_back();
        }
        m--;
    }
}