#include <bits//stdc++.h>

#ifndef LOCAL
#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#endif

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


int L = 20, T = 0;
vector<vector<int>> g, up;
vector<int> order, leftBound, rightBound, addTime, tin, tout, depth;


struct query {
    int time;
    char type; // + , - , ?
    int x, y;
};


void dfs(int v, int p, int d) {
    order.pb(v);
    tin[v] = T++;
    depth[v] = d;
    leftBound[v] = order.size() - 1;
    up[v][0] = p;
    for (int i = 1; i < L; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto u : g[v]) {
        dfs(u, v, d + 1);
    }
    order.pb(v);
    rightBound[v] = order.size() - 1;
    tout[v] = T++;
}


bool isParent(int v, int u) { // is u a v ancestor
    return tin[u] <= tin[v] and tout[u] >= tout[v];
}


int lca(int v, int u) {
    if (isParent(v, u)) {
        return u;
    }
    if (isParent(u, v)) {
        return v;
    }
    for (int i = L - 1; i >= 0; i--) {
        if (!isParent(u, up[v][i])) {
            v = up[v][i];
        }
    }
    return up[v][0];
}


struct stree1 { // +-1 on seg and min
    vector<ll> val, upd;
    int n;

    stree1() {
        n = order.size();
        val.resize(4 * n);
        upd.resize(4 * n);
    }

    void push(int v, int len) {
        val[v] += upd[v];
        if (len != 0) {
            upd[v * 2] += upd[v];
            upd[v * 2 + 1] += upd[v];
        }
        upd[v] = 0;
    }

    void add(int v, int l, int r, int ql, int qr, int d) {
        push(v, r - l);
        if (l > qr or r < ql) {
            return;
        }
        if (ql <= l and r <= qr) {
            upd[v] += d;
            push(v, r - l);
            return;
        }
        int mid = (l + r) / 2;
        add(v * 2, l, mid, ql, qr, d);
        add(v * 2 + 1, mid + 1, r, ql, qr, d);
    }

    ll getVal(int v, int l, int r, int pos) {
        push(v, r - l);
        if (l == r) {
            return val[v];
        }
        int mid = (l + r) / 2;
        if (pos <= mid) {
            return getVal(v * 2, l, mid, pos);
        } else {
            return getVal(v * 2 + 1, mid + 1, r, pos);
        }
    }

    void turnOn(int v) {
        add(1, 0, n - 1, leftBound[v], rightBound[v], -1);
    }

    void incV(int v, int delta) {
        add(1, 0, n - 1, leftBound[v], rightBound[v], delta);
    }

    void turnOff(int v) {
        add(1, 0, n - 1, leftBound[v], rightBound[v], 1);
    }

    bool isAlive(int v) {
        return getVal(1, 0, n - 1, leftBound[v]) == 0;
    }

    ll getUpSum(int v) {
        return getVal(1, 0, n - 1, leftBound[v]);
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<query> q;
    g.resize(n);
    up.resize(n, vector<int>(L));
    leftBound.resize(n);
    rightBound.resize(n);
    addTime.resize(n);
    depth.resize(n);
    tin.resize(n);
    tout.resize(n);

    for (int i = 1; i <= m; i++) {
        char c;
        cin >> c;
        int x, y;
        if (c == '!') {
            cin >> x >> y;
            x--;
            y--;
            g[x].pb(y);
            addTime[y] = i;
        } else {
            cin >> x;
            if (c == '?') {
                cin >> y;
            } else {
                y = x;
            }
            x--;
            y--;
            q.pb({i, c, x, y});
        }
    }
    dfs(0, 0, 1);
    stree1 onOff;
    stree1 upSum;
    vector<int> lastUnblocked = addTime;
    for (int i = 0; i < n; i++) {
        upSum.incV(i, lastUnblocked[i]);
    }
    for (query &cntQ : q) {
        int x = cntQ.x, y = cntQ.y;
        if (cntQ.type == '+') {
            onOff.turnOn(x);
            upSum.incV(x, cntQ.time - lastUnblocked[x]);
            lastUnblocked[x] = cntQ.time;
        } else if (cntQ.type == '-') {
            onOff.turnOff(x);
        } else {
            if (addTime[x] > cntQ.time or addTime[y] > cntQ.time
                or !onOff.isAlive(x) or !onOff.isAlive(y)) {
                cout << "-1" << "\n";
                continue;
            }
            int vR = upSum.getUpSum(x), uR = upSum.getUpSum(y);
            int l = lca(x, y);
            int lR = upSum.getUpSum(l);
            int edges = depth[x] + depth[y] - depth[l];
            int ans = cntQ.time * edges - (vR + uR - lR);
            cout << ans << "\n";
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}