#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

#define GROUPS
#ifdef GROUPS
    int _group = validator.group() == "" ? -1 : atoi(validator.group().c_str());
#endif

    int nlim = 200'000, mn = 0, mx = 1e9;
    if (_group == 1) nlim = 100;
    if (_group == 3) nlim = 1000;

    int n = inf.readInt(1, nlim, "n");
    inf.readSpace();
    int m1 = inf.readInt(mn, mx, "m_1");
    inf.readSpace();
    int m2 = inf.readInt(mn, mx, "m_2");
    inf.readEoln();
    inf.ensuref(m1 <= m2, "m_1 should be less than m2");

    int l_old = -1;
    for (int i = 0; i < n; i++) {
        int l = inf.readInt(mn, mx, format("l_%d", i + 1));
        inf.readSpace();
        int r = inf.readInt(mn, mx, format("r_%d", i + 1));
        inf.ensuref(l < r, "segment %d is empty", i + 1);

        if (_group == 4) {
            inf.ensuref(r - l <= 30, "segment %d is longer than 30 in group 4", i + 1);
        }
        if (_group == 2) {
            inf.ensuref(l >= l_old, "l_%d decreases in group 2", i + 1);
            l_old = l;
        }

        inf.readEoln();
    }

    inf.readEof();

}